package io.modules.sys.controller;
import io.common.annotation.LogOperation;
import io.common.constant.Constant;
import io.modules.item.dto.ArticleDTO;

import io.modules.item.service.ArticleService;
import io.common.page.PageData;
import io.common.utils.Result;
import io.common.validator.AssertUtils;
import io.common.validator.ValidatorUtils;
import io.common.validator.group.AddGroup;
import io.common.validator.group.DefaultGroup;
import io.common.validator.group.UpdateGroup;
import io.modules.item.service.DictService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.Parameters;

import java.util.List;
import java.util.Map;
/**
 * 文章表

 */
@RestController
@RequestMapping("item/article")
@Tag(name="文章表")
public class ArticleController {
    @Autowired
    private ArticleService articleService;


    @Autowired
    private DictService dictService;

    @GetMapping("page")
    @Operation(summary = "分页")
    @Parameters({
        @Parameter(name = Constant.PAGE, description = "当前页码，从1开始", in = ParameterIn.QUERY, required = true, ref="int") ,
        @Parameter(name = Constant.LIMIT, description = "每页显示记录数", in = ParameterIn.QUERY,required = true, ref="int") ,
        @Parameter(name = Constant.ORDER_FIELD, description = "排序字段", in = ParameterIn.QUERY, ref="String") ,
        @Parameter(name = Constant.ORDER, description = "排序方式，可选值(asc、desc)", in = ParameterIn.QUERY, ref="String"),
        @Parameter(name = "type", description = "类型", in = ParameterIn.QUERY, ref="String")
    })
    @RequiresPermissions("item:article:page")
    public Result<PageData<ArticleDTO>> page(@Parameter(hidden = true) @RequestParam Map<String, Object> params){
        PageData<ArticleDTO> page = articleService.page(params);
        return new Result<PageData<ArticleDTO>>().ok(page);
    }

    @GetMapping("{id}")
    @Operation(summary = "信息")
    @RequiresPermissions("item:article:info")
    public Result<ArticleDTO> get(@PathVariable("id") Long id){
        ArticleDTO data = articleService.get(id);

        return new Result<ArticleDTO>().ok(data);
    }

    @PostMapping
    @Operation(summary = "保存")
    @LogOperation("保存")
    @RequiresPermissions("item:article:save")
    public Result save(@RequestBody ArticleDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);
        List<String> existsList = dictService.isExistsList(dto.getIntroduction());
        if (!existsList.isEmpty()){
            return new Result().error("简介出现敏感词："+existsList);
        }
        List<String> contentExistsList = dictService.isExistsList(dto.getContent());
        if (!contentExistsList.isEmpty()){
            return new Result().error("发布内容出现敏感词："+ contentExistsList);
        }
        articleService.save(dto);
        return new Result();
    }
    @PutMapping
    @Operation(summary = "修改")
    @LogOperation("修改")
    @RequiresPermissions("item:article:update")
    public Result update(@RequestBody ArticleDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);
        articleService.update(dto);
        return new Result();
    }

    @DeleteMapping
    @Operation(summary = "删除")
    @LogOperation("删除")
    @RequiresPermissions("item:article:delete")
    public Result delete(@RequestBody Long[] ids){
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");
        articleService.delete(ids);
        return new Result();
    }



}
